# ListObjectsAsync

## Обзор
ListObjectsAsync асинхронно получает список объектов в AWS S3 Bucket.

Поддерживает рекурсивный обход каталогов с контролем глубины.

Поддерживает группировку каталогов по префиксам для уменьшения количества API вызовов.

## Возможности

- Использует aiobotocore для неблокирующих операций ввода-вывода.
- Группирует каталоги по префиксам для уменьшения количества API вызовов.
- Скачивает результат по страницам для обеспечения эффективного обхода длинных списков объектов.
- Поддерживает рекурсивный обход каталогов с контролем глубины.
- Использует стратегии повторных попыток AWS.

## Использование

```python
--8<-- "list.py"
```
Вы можете контролировать глубину рекурсии, указывая параметр max_depth, по умолчанию глубина не ограничена.

С помощью `max_folders` вы можете группировать каталоги по префиксам для уменьшения количества API вызовов.

### Детали реализации

[Группировка префиксов][async_s3.group_by_prefix.group_by_prefix] используется для сокращения количества API вызовов.
Конечно, это не всегда возможно, но в худшем случае это около 50 групп по одному символу для всех возможных символов в ключе объекта. 

И в большинстве случаев их намного меньше, например:

```
folder/0123.jpg
folder/0124.jpg
folder/0125.jpg
..
folder/9926.jpg
```

мы можем сжать до десяти групп:

```
folder/0
folder/1
...
folder/9
```

## Сгенерированная из исходников документация
[ListObjectsAsync][async_s3]
